#| 
   module      : lisp-init (prost)
   owner       :
   author      :
   explanation : 

                 initializations for Prost
       
   history     :

       04.08.89
       90.06.11 Franz Weber
		new operating system

   errors      :
   bugs        :
|#
  
(setq *load-verbose* nil)

(setf *print-case* :downcase)
; (setf *print-pretty* t)

; Dealing with 3.0

#+lcl3.0 (setq *load-binary-pathname-types*
	    #+sparc   '("s3bin")
	    #+mc68000 '("l3bin"))


; number of segments  (16 segments = 1MB)

(change-memory-management 
    :growth-limit 480  ; 30 MB
    :growth-rate 32    ;  2 MB
    :expand 30
    :expand-p t
    :reclamation-ratio 0.4)

(defparameter *mod-homedir* (concatenate 'string prefix "/tools/lisp"))
(defparameter *mod-home-path* `(,*mod-homedir*))

(require 'mod (concatenate 'string *mod-homedir* "/mod/v/startup"))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	   define HOMEDIRs of interesting MODULES here       	;;;;
;;;;       define also a require-function which loads		;;;;
;;;;	   the initial file of the module.			;;;;
;;;;								;;;;
;;;;   All files of a module are relative to the directories 	;;;;
;;;;   defined here.						;;;;
;;;;   When you change the directory of a Module you have 	;;;;
;;;;   only to change the defintions below.         		;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;  LIBrary MODULES		;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 ;; in the LIB-directory are a set of useful Modules
 ;; For loading some LIB-Module call (require-lib 'module)
 ;; The module "lisp-extension is loaded automatically and in CL
 ;; CL version 2.0 also the module "upgrade2-1".

(defparameter *lib-homedir* (concatenate 'string *mod-homedir* "/lib/"))
   
(defun require-lib (m) ; for loading LIB modules
   (require m (format nil "~A~A" *lib-homedir* m))
  )  
   
(mod-require "lib")
;(require-lib "startup")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;  MODULE	CASES		;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; is currently the flavor-version

(defparameter *cases-homedir* "/usr/odysseus/prost/weber/lisp/F-CASES/")

(defun require-cases ()
  (require 'cases (format nil "~Astartup" *cases-homedir*))
 )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;  MODULE	EARLEY		;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;  EARLEY
(defparameter *earley-homedir* "/fzi/prost/lisp/lib/earley/")

(defun require-earley () (mod-require "earley/v"))
; (defun require-earley ()
  ; (require 'earley (format nil "~Astartup" *earley-homedir*))
 ; )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;  MODULE	rul		;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;  rul
(defparameter *rul-homedir* "/fzi/prost/lisp/lib/rul/")

(defun require-rul ()
 (mod-require "rul/v")
 )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;   STARTING some PROGRAMS	;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun bm ()
  (cd "/usr1/herkules/tools/bm/CODE")
  (SETQ *THM-SUPPRESS-DISCLAIMER-FLG* T)
  (load "nqthm")
  (load-nqthm)
  (eval (list 'boot-strap 'nqthm))
  (cd "/usr1/herkules/tools/bm/PROST")
  (format t "~%Current directory is set to .../bm/PROST")
  (values))

#|
(format t "init for laser done : ~%  ~
	     load F-CASES with (require-cases) ~%  ~
	     load EARLEY  with (require-earley) ~%  ~
	     load RUL  with (require-rul) ~%  ~
	     load Boyer-Moore with (bm)~%~%")
 
|#
; (mod-require "tra")

 ; special settings

 (setq *print-circle* t)
 (compiler-options :messages nil :warnings nil)
 (setq *debug-print-level* 0)
 (setq *debug-print-length* 0)


(defvar *!!* nil)

(defun !! ()
    (if (or (equal ++ `(!!))(equal ++ `(!))) 
	(eval *!!*)
	(progn
	    (setq *!* +)
	    (setq *!!* ++) 
	    (eval ++)
	)
    )
)

(defvar *!* nil)

(defun ! ()
    (if (or (equal + `(!!))
	    (equal + `(!)))
	(eval *!*)
	(progn
	    (setq *!!* *!*)
	    (setq *!* +)
	    (eval +)
	)
    )
)
