#|
   module      : declaration
   owner       : Franz Weber
   author      : Franz Weber
   explanation :

        symbol declarations 

        (defflavor declaration (type picture is-constant) 
                               (parse-gen comparison copies)
            (:gettable-instance-variables type picture)
            (:init-keywords type picture is-constant)
        )

        (defmethod (declaration :is-variable) () (not [:is-constant]))
        (defmethod (declaration :is-constant) () is-constant)

   history     :

        91.03.04 Franz Weber

   errors      :
   bugs        : not completly implemented
                 com and copy not implemented
   todo        : 
|# 

(mod-require "logic/v2/expression/parse-gen/impls/parse-gen")
(mod-require "data/glo/v2/simple-aggregate-empty")


(defflavor declaration (type picture is-constant) 
    (simple-aggregate-empty parse-gen comparison copies)
    (:settable-instance-variables type picture is-constant)
    (:gettable-instance-variables type picture is-constant)
    (:init-keywords :type :picture :is-constant)
)

; ----- comparison
;@@@@@
;@@@ exp identity not considered
(defmethod (declaration :compare) (right)
    (if (eql self right) 'equal
        (let ((res [[:type] :compare [right :type]]))
            (if (equal res 'equal)
                (let ((res (flavor-compare picture [right :picture])))
                    (if (equal res 'equal)
                       (error "declarations: can't compare~%")
                        res
                    )
                )
                res
            )
        )
    )
)


; ----- declaration specific methods
(defmethod (declaration :is-variable) () (not [:is-constant]))
(defmethod (declaration :is-constant) () is-constant)

; ----- unparsing /dump

(defmethod (declaration :attribute-string) () [:picture])

(defmethod (declaration :attribute-lis) ()
    (let ((res (make-instance 'lis-list)))
        [res :move-in [:type]]
        res
    )
)

(defmethod (declaration :unparse) (&key (stream t))
    (format stream "~a." picture)
    [[:type] :unparse :stream stream]
    (when [:is-constant] (format stream ":"))
)

