#|
   module      : environment
   owner       : Franz Weber
   author      : Franz Weber
   explanation :

	environments for proving

	not complete yet

   history     :
  
	91.03.04 Franz Weber

   errors      :
   bugs        : 
   todo        : 
|# 

(defflavor environment () ())

(proclaim '(special *exp-environment*))
; is the default environment for parsing and other operations

(virtualmethod (environment :declare) (decl))

(defmethod (environment :unparse) (&key (stream t))
    (format stream "(")
    (let ((need-blank nil))
       [:iterate (x)
	   (if need-blank
	       (format stream " ")
	       (setq need-blank t)
	   )
	   [x :unparse :stream stream]
       ]
    )
    (format stream ")")
)


; ------------ Implementation as a list


(mod-require "data/lis/v2")

(defflavor environment-lis () (environment lis-list))

(defmethod (environment-lis :declare) 
    (type picture  &optional (is-constant nil))
    [:move-in
	(make-instance 'declaration
	    :type type
	    :picture picture
	    :is-constant is-constant
	    ;:father self
	)
    ]
)

; ------------------------------------------------------------
; ------------ for unification, but not in user-interface
; ------------------------------------------------------------

; create a declaration with a unique picture beginning with base,
; insert it into the environment and return a reference to it
(defmethod (environment :new-variable)(type-node &optional (base "v"))
  (let ((dec (make-instance 'declaration ;note the similarity to :declare 
			    :type type-node
			    :picture (uni-new-pic base)
			    :is-constant nil)))
    [:move-in dec]
    (make-instance 'reference :ref dec)))

; generate a new string
; base specifies a String used as prefix of the new string
; *uni-pic-count* stores a number inceremented each time uni-new-pic is called
(setq *uni-pic-count* 0)
(defun uni-new-pic (&optional (base "p"))
  (setq *uni-pic-count* (1+ *uni-pic-count*))
  (format nil "~A~D" base *uni-pic-count*))


(defun uni-new-abstraction (x) ; generate an abstraction with the same type as x
  (make-instance 'abstraction :type [x :expression-type]
		              :picture (uni-new-pic "z")
			      :is-constant nil))  ;???
	  

    


