#|
   module      : parse-gen
   owner       : Franz Weber
   author      : Franz Weber
   explanation : 

		general parse/unparse interface

		*parse-expression*
		*exp-environemnt*

		if t then unparse during printing else dump

		:unparse (&key (stream t))

		:print-self
		    additionaly obeys *print-unparse*

   history     :
  
        91.04.24 Franz Weber
   errors      :
   bugs        :
   todo        : 
|# 

(mod-require "data/glo/v2/simple-lin")
(mod-require "data/glo/v2/cop")
(mod-require "logic/v2/expression/environment/impls/environment")

(defvar *print-unparse* nil)
(setq *exp-environment* (make-instance 'environment-lis))

(defflavor parse-gen () (simple-linear-aggregate))

(virtualmethod (parse-gen :unparse) (&key (stream t)))

(defwhopper (parse-gen :print-self)
           (stream prindepth &optional (indent 0))

    (if (equal *print-level* prindepth)
       (format stream "#")
       (if *print-unparse*
	   (progn
	       (format stream "~VT" indent)
	       [:unparse :stream stream]
	   )
	   (continue-whopper-all)
       )
    )
)
