#|
   module      : type
   owner       : Franz Weber
   author      : Franz Weber/Olaf Mueller
   explanation :

	representation of types in the simple typed lambda calculus


	1. Types
	--------

	(defflavor type ()(simple-fix-tree))


	2. Type Nodes
	-------------

	(defflavor type-node () (parse-gen simple-linear-aggregate))


	3. Basic Types
	--------------

	(defflavor basic-type 
    	    (picture) 
    	    (type-node)
    	    (:gettable-instance-variables picture)
    	    (:settable-instance-variables picture)
    	    (:init-keywords picture)
	)

		a. generic implementations
		--------------------------

			compare
			deallocate
			copy-from
			attribute-string

	4. Function Types
	-----------------

	(defflavor function-type 
    	    (domain range) 
    	    (type-node)
    	    (:gettable-instance-variables domain range)
    	    (:settable-instance-variables domain range)
    	    (:init-keywords domain range)
	)

		a. generic implementations
		--------------------------

			compare
			copy
			deallocate
			index-of, set-elem, get-elem
			    transfer-elem-out, transfer-elem-in
			    iterate-non-recursice-method

			positions are 'domain 'range
     
   history     :
  
	91.03.04 Franz Weber
		 flavor base version
	92.06.04 Olaf Mueller
		 extended for unification

   errors      :
   bugs        : 
   todo        : 
|# 

(mod-require "logic/v2/expression/parse-gen/impls/parse-gen")
(mod-require "data/tre/v2/simple-tre")

; -------------------- Type Node

(defflavor type-node () (parse-gen simple-linear-aggregate copies))


