#|
   module      	: rule
   owner       	: Franz Weber
   author      	: Franz Weber
   explanation 	: 
   history     	:

	92.11.09 Franz Weber

   errors      	: 
   bugs        	: 

	uses own unification!

   todo        	:
   usage 	: 
|#

(mod-require "/fzi/prost/highlight/prover/logic/v2/unification/impls/E-unify")  

(defun convert-formula (s &key env)
  (rul-for-parse-expression s :env env)
)

(defmethod (expression-node :unify) 
    (f2 &key (env (make-instance 'environment-lis)))
  [:E-unify f2 env] 
)

(defmethod (expression-node :unparse) (&key env)
  [:unparse]
)


(defmethod (expression-node :apply-rule) (rule &key (env *exp-environment*))

    [:unify [rule :functor |:argument]
    |:map :result-type 'lis-list (x) [rule :argument |:apply-sub x] ]

)

(defmethod (expression-node :apply-rule-part) 
    (rule &key (env *exp-environment*))

    (let* ((left [rule :functor |:argument])
           (right [rule :argument])
           (functor-type (make-instance 'function-type
                           :domain [left :expression-type]
                           :range  [self :expression-type]) )
           (functor-declaration (make-instance 'declaration
                                   :picture "functor"
                                   :type functor-type
                                   :is-constant nil ))
           (exp (make-instance 'application
                   :functor (make-instance 'reference
			        :ref functor-declaration
                            )
                   :argument left
                ) )
           (res (make-instance 'application
                   :functor (make-instance 'reference
			        :ref functor-declaration
                            )
                   :argument right
                ) )
           )

         [:unify exp  
         |:map :result-type 'lis-list (x) [res :apply-sub x]
	 ]
     )


   
)

(defun pp (res-lis) 

    [res-lis :iterate (x) [x :beta-eta-reduce |:unparse] (terpri)] nil)


(defmethod (lis-list :unparse) () (pp self))

#| an example for the file "axioms"
----------------------------------------------------------------------
(setq e (rul-for-parse-environment
	 "(a.int  b.int  c.int  1.int: 2.int: 3.int: +.((int int) int):
	   R.(int int) S.int T.int
	   A.int B.int C.int
           F3.((int int) int) F2.(int int) F1.int PART.int H.int
            =.((bool int) int): ==.((bool bool) bool):)" 
	 ))
(setq *exp-environment* e)
(setq k1 (convert-formula "((+ a) b)" :env e))  ; \ Kommutativgesetz
(setq k2 (convert-formula "((+ b) a)" :env e))  ; / a+b = b+a

(setq a1 (convert-formula "((+ ((+ a) b)) c)" :env e))  ; \ Assozitivgesetz
(setq a2 (convert-formula "((+ a) ((+ b) c))" :env e))  ; / (a+b) + c = a + (b+c)

(setq f1 (convert-formula "((+ 1) 2)" :env e))
(setq f2 (convert-formula "((+ 1) ((+ 2) 3)" :env e))

(setq comm (rul-for-parse-expression "((= ((+ A) B)) ((+ B) A))"))
(setq ass (rul-for-parse-expression 
   "((= ((+ A) ((+ B) C))) ((+ ((+ A) B) ) C)"))

----------------------------------------------------------------------
|#
