#|
   module      : sub
   owner       : Franz Weber
   author      : Franz Weber
   explanation : sets of substitutions
     
   history     : 
	 90.08.07 
  
   errors      :
   bugs        :
   todo        : 
|# 

(mod-require "logic/v2/substitution/sub")
(mod-require "data/set/v2/set")

(defconstant sub-set-implementation 'set-lis)
(defconstant formula-set-implementation 'set-lis)

(defflavor sub-set () (set))

(defmethod (sub-set :elems-get) (key)
    [:reduce (el) (res (make-instance 'formula-set-implementation))
	[res :insert [el :get key]]
	res
    ]
)

(defmethod (sub-set :elems-insert-key) (key info)
    [:iterate (el) [el :insert-key key info]]
)

(defmethod (sub-set :elems-remove-key) (key)
    [:iterate (el) [el :remove-key key]]
)

(defmethod (sub-set :elems-apply-sub) (ft)
    [:reduce (el) (res (make-instance 'formula-set-implementation))
        [res :insert [el :apply-sub sub]]
	res
    ]
)

(defmethod (sub-set :elems-function-apply) (ft)
    [:iterate (el) [el :function-apply ft]]
)

(defmethod (sub-set :elems-function-abstract) (ft)
    [:iterate (el) [el :function-abstract ft]]
)

(defmethod (sub-set :elems-expand) ()
    [:iterate (el) [el :expand]]
)

