#|
   module      : bag-lis
   owner       : Franz Weber
   author      : Franz Weber
   explanation : 

	ADT bag implemented by a representation of ADT lis

	(definitmethod (bag-lis)
	    (&key (lis (make-instance 'lis-list)) (init-value nil))
	   
	   generate a bag implemented by lis
	   the initial contents are 'init-value' (an s-exp for bags)

   history     : 90.06.26 Version 1
   errors      :
   bugs        : 
|#

(mod-require "data/lis/v2")
(mod-require "data/set/v2/set")

(defflavor bag-lis (content) (set) (:init-keywords :lis :init-value))

; -------------------- constructors (page 57)
(definitmethod (bag-lis) 
    (&key (lis (make-instance 'lis-list))
	  (init-value nil))
    (setq content lis) [lis :clear]
    [:move-in-s-exp init-value]
)

(defmethod (bag-lis :clear) () [content :clear] self)

(defmethod (bag-lis :move) 
    (from-pos &key to-pos from)
    [self :move-in [from :move-out from-pos]]
)

(defmethod (bag-lis :move-in) (e  &key to-pos)
    [content :insert e]
)

(defmethod (bag-lis :move-out) (pos)
    [content :move-out pos]
)

(defmethod (bag-lis :get-elem) (i) [content :get-elem i])

(defmethod (bag-lis :index-of) (e) [content :index-of i])
; -------------------- Iterators (page 80)
(defiterationmethod (bag-lis :iterate-method) (f) 
    [content :calliterationmethod :iterate-method f])
