#|
   module      : cop
   owner       : Franz Weber
   author      : Franz Weber
   explanation : copyable objects
		 see below for explanation
   history     : 90.07.24 
   errors      :
   bugs        : copy doesn't work when parts of the object are
		 unbound. the specification should be extended (at
		 least for some subclasses).
|#

(mod-require "flavor/v4")
(defflavor copies () ())

(defmacro if-copy (object then &optional (else object))
  `(if (typep ,object 'copies) ,then ,else)
)

; -------------------- constructors (page 57)

(defmethod (copies :copy) () 
    [(make-instance (type-of self)) :copy-from self]
)
(virtualmethod (copies :copy-from) (from))


(virtualmethod (copies :deallocate) ())
(compile-flavor-methods copies)
