#|
   module      : lin-gen-test
   owner       : Franz Weber
   author      : Franz Weber
   explanation : test linear generic aggregate
   history     :
   errors      :
   bugs        :
|#

(mod-require "data/glo/v2/aggregate.test")
(mod-require "data/glo/v2/lin-gen")

(defflavor lin-gen-test () (generic-linear-aggregate aggregate-test))

; log should be five elements
(defmethod (lin-gen-test :test-map) (any lof)
    (and
       [:test-single-map any lof :iteration-order 'dont-care]
       [:test-single-map any lof :iteration-order 'from-first]
       [:test-single-map any lof :iteration-order 'from-last]
       [:test-result-object-map any lof :iteration-order 'dont-care]
       [:test-result-object-map any lof]
       [:test-result-object-map any lof :iteration-order 'from-last]
    )
)
(defmethod (lin-gen-test :test-single-map) (any lof &key 
    (iteration-order 'dont-care))
   (and
       [[:map :iteration-order iteration-order (x) x] :equal self]
       (equal [[:map :iteration-order iteration-order (x) nil] :count] [:count])
       (progn
       [:insert-s-exp lof]
       (let ((i [:find (second lof) :test 'eql])
	     (j  [:find (fourth lof) :test 'eql])
	    )
	    (if (equal iteration-order 'from-last)
		(progn
		    (setq ii j)
		    (setq jj i)
		)
		(progn
		    (setq ii i)
		    (setq jj j)
		)
	    )
	    (and
	    (let ((m [:map :iteration-order iteration-order :from ii :to jj (x) x]))
		(and
		    (equal [m :count] [:count :from ii :to jj
		    :iteration-order iteration-order])
		    (let ((ee t))
		       [:reduce :from i :to j (x) (k [m :first])
			  (setq ee (and (equal 
				       (flavor-compare 
					   x
					   [m :get-elem k]
				       )
				       'equal
				   ) ee)

			  )
			  [m :next k]
		       ]
		       ee
		    )
		)
	    )
	    (let ((m [:map :iteration-order iteration-order :part `(,i ,j) (x) x]))
		(and
		    (equal [m :count] [:count :from ii :to jj
		    :iteration-order iteration-order])
		    (let ((ee t))
		       [:reduce :part `(,i ,j) (x) (k [m :first])
			  #|
			  (format t "~a ~a ~a ~a~%"
			      x
			      k
			      [m :get-elem k]
			      ee
			  )
			  |#
			  (setq ee (and (equal 
				       (flavor-compare 
					   x
					   [m :get-elem k]
				       )
				       'equal
				   ) ee)

			  )
			  [m :next k]
		       ]
		       ee
		    )
		)
	    )
	    )
       )
       )
       (if (equal iteration-order 'dont-care)
	  [:test-map any lof :iteration-order 'from-first]
	  t
       )
       (if (equal iteration-order 'from-first)
	     [:test-map any lof :iteration-order 'from-last]
	     t
       )
   )
)

(defmethod (lin-gen-test :test-result-object-map) (any lof &key
(iteration-order 'dont-care))
    (and
       (not (eql [:map :iteration-order iteration-order (x) nil] self]))
       (eql [:map :iteration-order iteration-order :result-object any (x) x] any)
       (typep [:map :iteration-order iteration-order :result-type 'lis-tab (x) nil] 'lis-tab)
       (equal [:count] [[:map :iteration-order iteration-order :result-type 'lis-tab (x) nil] :count])
       (equal [:count] [[:map :iteration-order iteration-order :result-object any (x) nil] :count])
    )
)
