#|
   module      : simple-aggregate-empty
   owner       : Franz Weber
   author      : Franz Weber
   explanation : simple-aggregate-empty objects

	empty simple aggregate

   history     : 90.08.03
   errors      :
   bugs        : There should be no simple-aggregate-emptys but null aggregates !
		 see e.g. 'basic-type'
|#

(mod-require "flavor/v4")
(mod-require "data/glo/v2/simple-aggregate")
(mod-require "data/glo/v2/cop")

(defflavor simple-aggregate-empty () (simple-aggregate comparison copies))

; ----- simple aggregate

(defmethod (simple-aggregate-empty :elem-error) () (error "simple-aggregate-emptys have no elems"))
(defmethod (simple-aggregate-empty :index-of) (pos) [:elem-error])
(defmethod (simple-aggregate-empty :set-elem) (i e) [:elem-error])
(defmethod (simple-aggregate-empty :get-elem) (i) [:elem-error])
(defmethod (simple-aggregate-empty :transfer-elem-in) (i e) [:elem-error])
(defmethod (simple-aggregate-empty :transfer-elem-out) (i) [:elem-error])

(defiterationmethod (simple-aggregate-empty :iterate-method) (f)
            (when reflexive (funcall f self index-of-self)))

