(defflavormacro :print-self-macro object (stream prindepth &optional (indent 0))
   `(flavor-print-self ,object ,stream ,prindepth ,indent)
)

(defun flavor-print-self (object stream prindepth indent)
    (typecase object
	(simple-aggregate
	    [object :print-self stream prindepth indent]
	)
	(list
	   (flavor-print-self-list object stream prindepth indent)
	)
	(t
	   (format stream "~VT~A" indent
	      (with-output-to-string (s)
	      (write object :stream s :pretty nil
			     :level (when *print-level* 
					(- *print-level* (1+ prindepth)))
	      )
	      )
	   )
	)
    )
)

(defun flavor-print-self-list (object stream prindepth indent)
    (if (equal *print-level* prindepth)
       (format stream "#")
    (progn
    (format stream "~VT(" indent)
    (let ((need-blank nil) (count 0))
    (dolist (e object)
	(when (equal count *print-length*) 
	   (format stream " ...")
	   (return))
	(incf count)

	(if *print-pretty* 
	   (format stream "~%")
	   (when need-blank (format stream " "))
	)

        [e :print-self-macro 
	       stream 
	       (1+ prindepth)
	       (if *print-pretty* (+ indent 2) indent)]
    )
    )
    (format stream ")")
    )
    )
)

(defmethod (simple-aggregate :print-self) 
	   (stream prindepth &optional (indent 0))

    (if (equal *print-level* prindepth)
       (format stream "#")
       (progn
	  (format stream "~VT#<~a" indent (type-of self))
	  (let ((count 0))
	     [:iterate (x)
		 (when (equal count *print-length*) 
		     (format stream " ...")
		    (return))
		 (incf count)
		 (when *print-pretty* (format stream "~%"))
		 [x :print-self-macro 
		    stream 
		    (1+ prindepth) 
		    (if *print-pretty* (+ indent 2) indent)]
	     ]
	  )
	  (format stream ">")
       )
    )
)
