#|
   module      : com-lis-test
   owner       : Franz Weber
   author      : Franz Weber
   explanation : abstract data type setping implemented as test table
   history     : 90.06.26 Version 1
   errors      :
   bugs        :
|#

(mod-require "lis.test")
(mod-require "data/glo/v2/component")

(defflavor com-lis-test () (lis-test))

(defflavor test-integers (content) (comparison copies component)
    (:settable-instance-variables content)
    (:gettable-instance-variables content)
    (:init-keywords :content)
)

(defun mm (i) (make-instance 'test-integers :content i))

(defmethod (test-integers :compare) (right)
    (flavor-compare content [right :content])
)

(defmethod (test-integers :copy-from) (from)
    (setq content [from :content])
    self
)

(defmethod (test-integers :transfer-from) (from)
    (setq content [from :content])
    self
)

(defmethod (test-integers :deallocate) () (setq content nil))

(defmethod (test-integers :dump) (depth) 
    (format t "~VT~A~%" depth content))
(defmethod (test-integers :+) (right)
    (+ content (if (instancep right) [right :content] right ))
)

(defmethod (com-lis-test :generate-any) () (mm 1))
(defmethod (com-lis-test :generate-lof) () (list (mm 1) (mm 2) (mm 3)))
(defmethod (com-lis-test :generate-objects) ()
    (list
	(make-instance (type-of self) :init-value '())
	(make-instance (type-of self) :init-value (list (mm 1) (mm 2) (mm 3) (mm 4)))
	(make-instance (type-of self) :init-value (list (mm 1)))
	(make-instance (type-of self) :init-value (list (mm 1) (mm 2) (mm 7) (mm
	8)))
    )
)
