#|
   module      : dequeue
   owner       : Franz Weber
   author      : Franz Weber
   explanation : 

	ADT dequeue (double ended queues)
	derived from ADT lis

	A lot of methods should be hidden from list. This is not done
	up to now. Note, that only the following positions and parts
	are allowed:

	insert position: 'first 'last
	remove position: 'first 'last  
	part: 'whole-struct
	
	There are the following dequeue specific methods:

	(defmethod (dequeue :push) (e) [:insert e :to-pos 'first])
	(defmethod (dequeue :pop) (e) [:remove 'first])
	(defmethod (dequeue :top) () [:get-elem 'first])
	(defmethod (dequeue :requeue) (e) [:insert e :to-pos 'last])
	(defmethod (dequeue :dequeue) () [:remove 'last])
        (defmethod (dequeue :last-elem) () [:get-elem [:last]])

	The names are selected in this way, that they are compatible
	with stacks and lists. However 'top' is a synonym for 'car'.

   history     : 91.03.01 Version 1
   errors      :
   bugs        :
|#

(mod-require "data/lis/v2")

(defflavor dequeue () (lis))

(defmethod (dequeue :push) (e) [:insert e :to-pos 'first])
(defmethod (dequeue :pop) (e) [:remove 'first])
(defmethod (dequeue :top) () [:get-elem 'first])
(defmethod (dequeue :requeue) (e) [:insert e :to-pos 'last])
(defmethod (dequeue :dequeue) () [:remove 'last])
(defmethod (dequeue :last-elem) () [:get-elem [:last]])

; note that many operations are forbidden for dequeues
