#|
   module      : queue
   owner       : Franz Weber
   author      : Franz Weber
   explanation : 

	ADT queue
	derived from ADT lis

	A lot of methods should be hidden from list. This is not done
	up to now. Note, that only the following positions and parts
	are allowed:

	insert position: 'first
	remove position: 'last
	part: 'whole-struct
	
	There are the following queue specific methods:

	(defmethod (queue :push) (e) [:insert e :to-pos 'first])
	(defmethod (queue :dequeue) () [:remove 'last])
        (defmethod (queue :last-elem) () [:get-elem [:last]])

   history     : 91.03.01 Version 1
   errors      :
   bugs        :
|#

(mod-require "data/lis/v2")

(defflavor queue () (lis))

(defmethod (queue :push) (e) [:insert e :to-pos 'first])
(defmethod (queue :dequeue) () [:remove 'last])
(defmethod (queue :last-elem) () [:get-elem [:last]])

; note that many operations are forbidden for queues
