#|
   module      : set-lis
   owner       : Franz Weber
   author      : Franz Weber
   explanation : 

	ADT set implemented by a representation of ADT lis

	(definitmethod (set-lis)
	    (&key (lis (make-instance 'lis-list)) (init-value nil))
	   
	   generate a set implemented by lis
	   the initial contents are 'init-value' (an s-exp for sets)

   history     : 90.06.26 Version 1
   errors      :
   bugs        : 
|#

(mod-require "data/lis/v2")
(mod-require "data/set/v2/set")

(defflavor set-lis (content) (set) (:init-keywords :lis :init-value))

; -------------------- constructors (page 57)
(definitmethod (set-lis) 
    (&key (lis (make-instance 'lis-list))
	  (init-value nil))
    (setq content lis) [lis :clear]
    [:move-in-s-exp init-value]
)

(defmethod (set-lis :clear) () [content :clear] self)

(defmethod (set-lis :move) 
    (from-pos &key to-pos from)
    [self :move-in [from :move-out from-pos]]
)

(defmethod (set-lis :move-in) (e  &key to-pos)
    (let ((res [content :find e]))
	(if res
	    res
	    [content :move-in e]
	)
    )
)

(defmethod (set-lis :move-out) (pos)
    [content :move-out pos]
)

(defmethod (set-lis :get-elem) (i) [content :get-elem i])

(defmethod (set-lis :index-of) (i) [content :index-of i])
; -------------------- Iterators (page 80)
(defiterationmethod (set-lis :iterate-method) (f) 
    [content :calliterationmethod :iterate-method f])

; -------------------- Find, Skip and Count (page 89)


; -------------------- Order Dependent Operations
