#|
   module      : set
   owner       : Franz Weber
   author      : Franz Weber
   explanation : 
   
	abstract data type set
	derived from unordered

	additional methods for union, intersection and set difference

	4. Set Specific Operations
	--------------------------

	(defmethod (set :union) (right) ...)
		well, what do you think it is ?
	(defmethod (set :intersection) (right)
	(defmethod (set :difference) (right)
		self - right

   history     : 90.06.26 Version 1
   errors      :
   bugs        : 
|#

(mod-require "data/glo/v2/unordered")
(mod-require "data/lis/v2/lis-list")

(defflavor set () (unordered))

; -------------------- Specific Operations

(defmethod (set :union) (right)
    [right :iterate (elem) [:insert elem]])

(defmethod (set :intersection) (right)
    [:iterate 'move (elem in) (unless [right :find elem] [:remove in])])

(defmethod (set :difference) (right)
    [:iterate 'move (elem in) (when [right :find elem] [:remove in])])

; out of efficency reasons

(defmethod (set :subset) (right)
  [:forall (elem) [right :is-elem elem]]
)

