#|
   module      : set-test
   owner       : Franz Weber
   author      : Franz Weber
   explanation : abstract data type setping implemented as test table
   history     : 90.06.26 Version 1
   errors      :
   bugs        :
|#

(mod-require "data/set/v2/set")
(mod-require "data/glo/v2/aggregate.test")

(defflavor set-test () (set aggregate-test))

(defmethod (set-test :test-index-of) (any lof)
    [:insert any]
    (equal [:get-elem [:index-of `(at-index ,[:find any])]] any)
)

(defmethod (set-test :test-swap) (&rest disc) t)
(defmethod (set-test :test-set-elem) (&rest disc) t)
(defmethod (set-test :test-transfer-elem-in) (&rest disc) t)
(defmethod (set-test :test-transfer-elem-out) (&rest disc) t)
(defmethod (set-test :test-modify-elem) (&rest disc) t)

(defmethod (set-test :generate-any) () 1)
(defmethod (set-test :generate-lof) () (list 1 2 3))
(defmethod (set-test :generate-objects) ()
    (list
	(make-instance (type-of self) :init-value '())
	(make-instance (type-of self) :init-value '(1 2 3 4))
	(make-instance (type-of self) :init-value '(1))
	(make-instance (type-of self) :init-value '(1 2 7 8))
    )
)
