#|
   module      : key-stack
   owner       : Franz Weber
   author      : Franz Weber
   explanation : 

	ADT stack enriched by a key/info structure of the componente
	objects.

        (defflavor key-stack () (stack key-generic-aggregate))

	special methods:

	(defmethod (key-stack :push-key) (key info)
	    [:push (pair key info)])
	(defmethod (key-stack :top-key) () (key-of [:top]))
	(defmethod (key-stack :top-info) () (info-of [:top]))

   history     : 90.06.26 Version 1
   errors      :
   bugs        :
|#

(mod-require "data/stack/v2/stack")
(mod-require "data/glo/v2/key-gen")

(defflavor key-stack () (stack key-generic-aggregate))

(defmethod (key-stack :push-key) (key info)
    [:push (pair key info)]
)

(defmethod (key-stack :top-key) () (key-of [:top]))
(defmethod (key-stack :top-info) () (info-of [:top]))
