#|)
   module      : lazylist
   owner       : Peter Sanders
   author      : Peter Sanders
   explanation : Lisp like implementation of lazy-lists 
                 described in Abelson, Sussman: Structure and
                 Interpretation of Computer Programs
   history     : 2/12/91 created
   errors      :
   bugs        : 
   todo        : 

|# 

(defmacro lazy-delay (a) `(lazy-cache (function (lambda () ,a))))

(defun lazy-force (a) (funcall a))

(defun lazy-car (l) (car l))

(defun lazy-cdr (l) (lazy-force (cdr l)))

(defmacro lazy-cons (a b) `(cons ,a (lazy-delay ,b)))

(defun lazy-cache (proc)
  (let ((already-run nil)(result nil))
    (function (lambda ()
		(if already-run 
		    result
		    (setq already-run t result (funcall proc)))))))
