(defparameter *font-homedir* "/usr/fzips5/prost/weber/lisp/fonts/")
                  
(defun select-font ()
 "makes a menu to select from all fonts in *font-homedir*
  the selected font becomes the *default-font*"
  (let ((font-files (directory *font-homedir*))
        font-choices font-menu font-name selected-font)
   (setq font-choices 
     (mapcar #'(lambda (file) (cons (pathname-name file) file))
             font-files))
    ; menu shows the font-names and returns the font-filenames
   (setq font-menu (make-menu font-choices :x 10 :y 10
                              :title "Select default font"))   
   (display-menu font-menu)
   (unwind-protect
    (loop 
     (sleep 0.5)
     (when (menu-state font-menu)
       (when (menu-value font-menu)
         (setq font-name
            (pathname-name (menu-value font-menu)))
         (setq selected-font
           (or (find-font font-name)
               (find-font (read-from-string font-name))
               (load-font (menu-value font-menu))))
         (setq *default-font* selected-font))
       (return)))
    (clear-menu font-menu))
  *default-font*
 ))
 
