;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;								;;;;
;;;;			 LIB MODULES				;;;;
;;;;								;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; This is different from other module startups in that
;;; the LIB provides different modules which are not loaded automatically.
;;; Only the modules "lisp-extension" (and "upgrade2-1" in CL-version 2.0)
;;; are always loaded.
;;; If one needs some other LIB-module one calls (require-lib module)


#| defined in lisp-init
 (defun require-lib (m)
   (require m (format nil "~A~A" *lib-homedir* m))
  )
|#  

;; load the STANDARD MODULE(s)
(require-lib "lisp-extension")
(when (search " 2.0." (lisp-implementation-version))
      (require-lib "upgrade2-1") )

(when (search " 3.0." (lisp-implementation-version))
      (require-lib "adapt3") )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UTILITIES

(defun lib-file (&rest pathes)
  "concatenatates *lib-homedir* and the concatenation of pathes"
  (format nil "~A~{~A~}" *lib-homedir* pathes) )

(defun ED-LIB (&optional (module "lisp-extension"))
    (shell (format nil
              "cd ~A ; ~
               textedit ~@[~A.lisp~] ~
                  -width 80 -height 35 ~
                  ~@[-icon_image ~A~]   &"
               *lib-homedir*
               (when (probe-file (lib-file module ".lisp"))
                    module)
                 ; if there is a icon-file *lib-homedir*/lib-ed.icon
                 ; this icon is used for textedit.
               (let ((i (probe-file
                            (lib-file "lib-ed.icon" )))
                     )
		   (when i (namestring i))
	        )
            )
     )
)
  
(defun COMPILE-LIB (&optional (module "lisp-extension"))
  (compile-file (lib-file module))
 )
 
(defun LOAD-LIB (&optional (module "lisp-extension"))
  (load (lib-file module))
 )

